#include <stdio.h>

#include <linux/capability.h>
#include <cap-ng.h>

void printcaps(const char *prefix, int which) {
	int count = 0;
	fprintf(stdout, "%s", prefix);
	for (int i = 0; i <= CAP_LAST_CAP; i++) {
		if (capng_have_capability(which, i) == 1) {
			if (count > 0) fprintf(stdout, ", ");
			if (count % 6 == 0) fprintf(stdout, "\n");
			fprintf(stdout, "%s", capng_capability_to_name(i));
			count++;
		}
	}
	if (! count) fprintf(stdout, "\n(none)");
	fprintf(stdout, "\n\n");
	fflush(stdout);
}

int main(void) {
	capng_get_caps_process();
	printcaps("Effective capabilities:", CAPNG_EFFECTIVE);
	printcaps("Permitted capabilities:", CAPNG_PERMITTED);
	return 0;
}

